<?php


function mspro_shopee_getUrl($url){
    $host = 'shopee.com.my';
    $parse = parse_url($url);
    if( isset($parse['host']) ){
        $host = $parse['host'];
    }
    
    if(stripos($url , '-i.') > 1){
        $res = explode('-i.' , $url);
        $res = explode('.' , $res[1] , 2);
        if(is_array($res) && isset($res[0]) && isset($res[1]) ){
            $url = 'https://' . $host . '/api/v2/item/get?itemid=' . $res[1] . '&shopid=' . $res[0];
            // echo $url;
            $html = getUrl($url);
            if($html){
                $html =  (array) json_decode('[' . $html . ']' , 1);
            }
            if(isset($html[0]['item'])){
                return $html[0]['item'];
            }
           //echo '<pre>' . print_r($html , 1) . '</pre>';exit;
            return $html;
        }
    }elseif(stripos($url , '/product/') > 1){
        $res = explode('?' , $url);
        $res = explode('/product/' , $res[0]);
        $res = explode('/' , $res[1]);
        if(is_array($res) && isset($res[0]) && isset($res[1]) ){
            $url = 'https://' . $host . '/api/v2/item/get?itemid=' . $res[1] . '&shopid=' . $res[0];
            // echo $url;
            $html = getUrl($url);
            if($html){
                $html =  (array) json_decode('[' . $html . ']' , 1);
            }
            if(isset($html[0]['item'])){
                return $html[0]['item'];
            }
            //echo '<pre>' . print_r($html , 1) . '</pre>';exit;
            return $html;
        }
    }
    return '';
}

function mspro_shopee_title($html){
   // echo '<pre>FF' . print_r($html , 1) . '</pre>';  // exit;
   //  echo $html;exit;
 	if(isset($html['name'])){
 	    return $html['name'];
 	}
    return '';
}

function mspro_shopee_description($html){
	$res = '';
		
	if(isset($html['description'])){
	    $res .= str_replace('
', '<br />' ,$html['description']);
	}

	//echo 'RES:' . $res;exit;
	return $res;
}


function mspro_shopee_price($html){
    if(isset($html['price'])){
       return (float) ( $html['price'] / 100000);
    }
	
    return '';
}


function mspro_shopee_sku($html){
    return mspro_shopee_model($html);
}

function mspro_shopee_model($html){
    if(isset($html['itemid'])){
       return $html['itemid'] ;
    }
    return '';
}


function mspro_shopee_manufacturer($html){
    $res = '';

    if(isset($html['brand'])){
        $res = trim($html['brand']);
    }

    return $res;
}

function mspro_shopee_quantity($html){
    $res = '';

    if(isset($html['stock'])){
        $res = (int) trim($html['stock']);
    }

    return $res;
}

function mspro_shopee_meta_description($html){
       return mspro_shopee_title($html);
}

function mspro_shopee_meta_keywords($html){
    return mspro_shopee_title($html);
}


function mspro_shopee_main_image($html){
	$arr = mspro_shopee_get_images_arr($html);
	if(isset($arr[0]) && strlen($arr[0]) > 0){
		return $arr[0];
	}
	return '';
}


function mspro_shopee_other_images($html){
	$arr = mspro_shopee_get_images_arr($html);
	if(count($arr) > 1){
		unset($arr[0]);
		return $arr;
	}
	return array();
}


function mspro_shopee_get_images_arr($html){
        $out = array();
        
        if(isset($html['images']) && is_array($html['images']) && count($html['images']) > 0){
            foreach($html['images'] as $img){
                $out[] = 'https://cf.shopee.com.my/file/' . $img;
            }
        }
        
        //echo '<pre>'.print_r($out , 1).'</pre>';exit;
        return $out;
}




function mspro_shopee_options($html){
    $out = array();
    
    
    if(isset($html['models']) && is_array($html['models']) && count($html['models']) > 0 &&
       isset($html['tier_variations'][0]['name']) && !is_array($html['tier_variations'][0]['name']) && strlen($html['tier_variations'][0]['name']) > 0){
            $OPTION = array();
            $OPTION['name'] = trim($html['tier_variations'][0]['name']);
            $OPTION['type'] = "select";
            $OPTION['required'] = true;
            $OPTION['values'] = array();
            foreach($html['models'] as $option_value){
                if(isset($option_value['name']) && !is_array($option_value['name']) && strlen(trim($option_value['name'])) > 0 && 
                   isset($option_value['normal_stock']) && !is_array($option_value['normal_stock']) &&  (int) trim($option_value['normal_stock']) > 0 ){
                        $OPTION['values'][] = array('name' => trim($option_value['name']) , 'quantity' => (int) trim($option_value['normal_stock'])  , 'price' => 0);
                }
            }
            if(count($OPTION['values']) > 0){
                $out[] = $OPTION;
            }
    }
    // echo '<pre>'.print_r($out , 1).'</pre>';exit;
    return $out;
}

function mspro_shopee_attributes($html){
    $out = array();
    
    if(isset($html['attributes']) && is_array($html['attributes']) && count($html['attributes']) > 0){
        foreach($html['attributes'] as $posAttr){
            $ATTR = array();
            $ATTR['group'] = 'Product Specifications';
            if(isset($posAttr['name']) && isset($posAttr['value']) ){
                $ATTR['name'] = trim($posAttr['name']);
                $ATTR['value'] = trim($posAttr['value']);
                $out[] = $ATTR;
            }
             
        }
    }
    // echo '<pre>'.print_r($out , 1).'</pre>';exit;

    return $out;
}


function mspro_shopee_noMoreAvailable($html){
    if(strpos($html , 'Out of Stock') > 0){
        return true;
    }
	return false;
}
